using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraController : MonoBehaviour
{
    //SK 203-595
    public float minX;
    public float maxX;
    public Transform target;
    public Vector3 offset;


    public (float ,float) defaultConstraint;

    private void Awake()
    {
        
    }


    private void Start()
    {
        oldPosition = target.position + offset;
        defaultConstraint = (minX, maxX);

    }


    public void ResetToDefault()
    {
        minX = defaultConstraint.Item1;
        maxX = defaultConstraint.Item2;
    }
    public void SetCameraMax(float max)
    {
        this.maxX = max;

    }
    public void SetCameraMin(float min)
    {

        this.minX = min;
    }
    Vector3 oldPosition;
    private void Update()
    {
        if (target != null)
        {
            transform.position = Vector2.Lerp(transform.position, oldPosition, Time.deltaTime);
            transform.position = new Vector3(transform.position.x, transform.position.y, -5f);


            if (target.position.x > maxX) return;
            if (target.position.x < minX) return;


            oldPosition = (Vector2)target.position + (Vector2)offset;



        }
    }
}
