using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.SceneManagement;

public enum PlayerState
{
    UnableToDoShit,
    Default
}

public enum Sanity
{
    Normal,
    KindaInsane,
    FullApe
}
public class PlayerController : MonoBehaviour, IDamagableEntity
{
    public bool isDebug;
    public float velocity;
    public GameObject InteractionDisplayer;

    public GameObject explosion;
    public Sanity sanity;

    private int sanityPoints;

    [Header("Health")]
    public EntityHealthProperties healthProperties;

    [Header("UI")]
    public TextMeshProUGUI healthUI;

    private Camera cam;

    private PlayerState PlayerState = PlayerState.Default;
    public Transform target;

    private Vector3 initialPosition;

    private Collider2D colly;
    SpriteRenderer renderer;
    [Header("Hand")]
    public float handMaxRadius;
    public PlayerHand rightHand;
    public PlayerHand leftHand;


    private Rigidbody2D riggy;

    [Header("Player mood")]
    public WorldDialogueController dialogueController;


    public Sprite corruptedSprite;

    private bool canDash;



    
    private void Start()
    {

        sanityPoints = 100;
        UpdateUI();

    }




    public bool canAttack = false;


    public void DecreaseSanity(int amount)
    {
        sanityPoints -= amount;
        UpdateSanity();

    }
    private void UpdateSanity()
    {
        if (sanityPoints >= 75)
        {
            sanity = Sanity.Normal;
        }
        else if (sanityPoints >= 40 && sanityPoints < 75)
        {
            sanity = Sanity.KindaInsane;
        }
        else sanity = Sanity.FullApe;
    }

    private void OnValidate()
    {
        if (canAttack)
        {
            ReadyArms();
        }
    }

    public void CanAttack(bool can)
    {
        canAttack = can;
        if (can)
        {
            ReadyArms();
        }


    }
    private void ReadyArms()
    {
       
        rightHand.isReady = true;
        leftHand.isReady = true;
        rightHand.gameObject.SetActive(true);
        leftHand.gameObject.SetActive(true);
    }
    private void Awake()
    {
        initialPosition = transform.localPosition;
        cam = FindObjectOfType<Camera>();
        riggy = GetComponent<Rigidbody2D>();
        renderer = GetComponent<SpriteRenderer>();
        colly = GetComponent<Collider2D>();
    }


    public void UpdateUI()
    {
        healthUI.text = healthProperties.currentHealth.ToString();
    }
   

    public void TurnIntoCorruptedBeing()
    {
        renderer.sprite = corruptedSprite;
    }
    public void ActivateUI(bool afirm)
    {
        healthUI.gameObject.SetActive(afirm);
        if (afirm)
        {
            UpdateUI();
        }
    }

    public void SetPlayerThoughts(string message, float time, int delay = 0)
    {

        dialogueController.SetText(message, time, delay);
     

    }


  
    public void TriggerHungry()
    {
      

    }

    public void GiveControlToPlayer()
    {
        PlayerState = PlayerState.Default;
    }

    public void RemoveControllFor(float duration)
    {

        riggy.velocity = Vector2.zero;
        StartCoroutine(DoRemoveFor(duration));
    }
    IEnumerator DoRemoveFor(float duration)
    {
        RemoveControlToPlayer();
        yield return new WaitForSeconds(duration);
        GiveControlToPlayer();

    }
    public void RemoveControlToPlayer()
    {
        riggy.velocity = Vector2.zero;
        PlayerState = PlayerState.UnableToDoShit;
    }


    IInteractable currentInteractable;

    private void OnTriggerEnter2D(Collider2D collision)
    {
         if(collision.tag =="hand") return;
        IInteractable i0 = collision.GetComponent<IInteractable>();
        if(i0 != null)
        {
            currentInteractable = i0;
            InteractionDisplayer.gameObject.SetActive(true);


        }
        
    }


    IEnumerator StartDashCC()
    {
        float timer = 3;
        while(timer > 0)
        {
            timer -= Time.deltaTime;
            yield return null;
        }
        canDash = true;
    }

    public void CanUseDash(bool can)
    {
        canDash = can;
    }

    IEnumerator Dash(Vector2 force)
    {
        colly.enabled = false;
        canDash = false;
        StartCoroutine(StartDashCC());
        Color c0 = renderer.color;
        Color c1 = new Color(c0.r, c0.g, c0.b,0);
        renderer.color = c1;
        riggy.AddForce(force, ForceMode2D.Impulse);
        yield return new WaitForSeconds(0.2f);
        renderer.color =  new Color(c0.r,c0.g,c0.b,255);
        colly.enabled = true;

    }
    private void OnTriggerExit2D(Collider2D collision)
    {
        IInteractable i0 = collision.GetComponent<IInteractable>();
        if(currentInteractable != null && i0 == currentInteractable)
        {
            InteractionDisplayer.gameObject.SetActive(false);
            currentInteractable = null;
        }
    }

    private float interactionTimer;


    private void Update()
    {
        
        switch (PlayerState)
        {
            case PlayerState.UnableToDoShit:
            
                break;
            case PlayerState.Default:


                if (Input.GetKeyUp(KeyCode.A) || Input.GetKeyUp(KeyCode.D)){
                    riggy.velocity = Vector2.zero;
                }

                    interactionTimer++;
                if (Input.GetKeyDown(KeyCode.E))
                {
                    if(currentInteractable != null && interactionTimer >= 1)
                    {
                        currentInteractable.OnInteract(this);
                        interactionTimer = 0;

                    }
                }

                if (Input.GetKeyDown(KeyCode.Mouse0) && canAttack)
                {
                    Vector3 pos = Utils.GetMouseToScreenWorld();
                    
                    pos.z = 0f;

                    if (rightHand.isReady)
                    {
                        rightHand.SendToLocation(pos);

                    }
                    else if(leftHand.isReady)
                    {
                      leftHand.SendToLocation(pos);
                    }
                  

                }

                if (Input.GetKey(KeyCode.D))
                {
                    riggy.velocity = new Vector2(velocity, 0);


                    if (Input.GetKeyDown(KeyCode.LeftShift) && canDash)
                    {
                        StartCoroutine(Dash(new Vector2(250, 0)));
                    }
                }
               
               

                    if (Input.GetKey(KeyCode.A))
                {


                    riggy.velocity = new Vector2(-velocity, 0);

                    if (Input.GetKeyDown(KeyCode.LeftShift) && canDash)
                    {
                        StartCoroutine(Dash(new Vector2(-250, 0)));
                    }

                }
                //if (target != null)
                //{
                //    Vector3 direction = target.transform.position - transform.position;


                //    Vector3 distanceToTarget = Vector3.ClampMagnitude(direction, handMaxRadius);


                //    Vector3 final = transform.position + distanceToTarget;
                //    hand.transform.position = final;
                //}
                break;
            default:
                break;
        }

      
    }

    private bool canReceiveDamage = true;
    IEnumerator InvFrames()
    {
        canReceiveDamage = false;

        float t = 0;
        while (t < 1)
        {

            t++;
            yield return new WaitForSeconds(1f);

        }

        canReceiveDamage = true;
    }
    public void TakeDamage(float amount)
    {
        if (!canReceiveDamage) return;
        healthProperties.currentHealth -= amount;
        UpdateUI();
        StartCoroutine(OnHealthReduce());
        StartCoroutine(InvFrames());

        if(healthProperties.currentHealth <= 0)
        {
           
            PlayerState = PlayerState.UnableToDoShit;
          
            Instantiate(explosion, transform.position, Quaternion.identity);
            TurnIntoCorruptedBeing();
            StartCoroutine(DoDie());
        }

    }
    
    IEnumerator DoDie()
    {
        yield return new WaitForSeconds(3f);
        SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex);
    }
    private IEnumerator OnHealthReduce()
    {
        healthUI.color = Color.red;
        yield return new WaitForSeconds(0.4f);
        healthUI.color = Color.white;
    }
    private IEnumerator OnHealthGain()
    {
        healthUI.color = Color.green;
        yield return new WaitForSeconds(0.4f);
        healthUI.color = Color.white;
    }

    public void IncreaseHealth(int amount)
    {
        healthProperties.currentHealth += amount;
        UpdateUI();
        StartCoroutine(OnHealthGain());

    }

    public void PushBack(Vector2 direction)
    {
        riggy.AddForce(direction);

    }
}
