using System.Collections;
using System.Collections.Generic;
using UnityEngine;



internal enum HandState { Resting, Attacking }
public class PlayerHand : MonoBehaviour
{
    

    HandState handState;
    PlayerController p;
    Vector2 startPos;
    public bool isReady;

    public GameObject refa;
    private void Awake()
    {
        startPos = transform.localPosition;

        int i0 = LayerMask.NameToLayer("hand");
        int i2 = LayerMask.NameToLayer("player");

        Physics2D.IgnoreLayerCollision(i0, i2, true);
    }



    public bool isAttacking;
    Coroutine sendToLocation;


    private void Update()
    {
        if(handState == HandState.Resting) transform.position = refa.transform.position;
        if(refa != null)
        {
           transform.RotateAround(transform.position, new Vector3(0, 0, 1), 1);

        }
    }
    private void OnTriggerEnter2D(Collider2D collision)
    {

     
        if (handState == HandState.Resting) return;
        
        IDamagableEntity damagableEntity = collision.GetComponent<IDamagableEntity>();
        
        if (damagableEntity != null)
        {
            if (sendToLocation != null)
            {

                Vector2 direction = collision.transform.position - transform.position;
                
                damagableEntity.TakeDamage(1);
                damagableEntity.PushBack(direction.normalized * 100);
                StopCoroutine(sendToLocation);
                ReturnToPosition();
            }
        }
    }


    //private void OnTriggerEnter2D(Collider2D collision)
    //{

    //    IDamagableEntity damagableEntity = collision.GetComponent<IDamagableEntity>();
    //    if (damagableEntity != null)
    //    {
    //        if (sendToLocation != null)
    //        {
    //            StopCoroutine(sendToLocation);
    //            ReturnToPosition();
    //        }
    //    }
    //}


    public void SendToLocation(Vector2 location)
    {
        if (!isReady) return;


        
        handState = HandState.Attacking;
        isReady = false;
        sendToLocation =  StartCoroutine(Utils.LerpPosition(transform, location, 0.2f, () => ReturnToPosition()));
       
    }
    public void ReturnToPosition()
    {
     
        StartCoroutine(Utils.LerpPositionLocally(transform, startPos, 0.2f, () => {
            isReady = true;
            handState = HandState.Resting;


            }));
    }

 

}
